# -*- coding: utf-8 -*-
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, urlunparse, urljoin, parse_qs
except ImportError:
    from urllib.parse import urlparse, urlunparse, urljoin, parse_qs
import sys, re, json
from bs4 import BeautifulSoup


def httpget(url):
    request = Request(url)
    request.add_header('User-Agent',
                       'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36')
    try:
        return urlopen(request).read().decode('utf-8')
    except:
        try:
            return urlopen(request).read().decode('gbk')
        except:
            return False


def htmlparser(content):
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(content, 'html.parser')
    return BeautifulSoup(content, 'html5lib')


def test1(url):
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    content = httpget(url)
    if not content:
        return {'code': 't66y 100'}
    items = []
    soup = htmlparser(content)
    for e1 in soup.select('td.tal'):
        title = e1.find(text=True).strip()
        if not title:
            continue
        if ord(title[0]) == 8593:
            continue
        n = e1.find('h3')
        if not n:
            continue
        n = n.find('a')
        if not n:
            continue
        if 'href' not in n.attrs:
            continue
        suburl = n.attrs['href']
        title += n.find(text=True).strip()
        items.append({'title': title, 'url': urljoin(url, suburl)})
    url1 = 'https://t66y.com/thread0806.php?fid=22&page=%d' % (page + 1)
    items.append({'title': 'Next Page', 'url': url1})
    return {'item': items}


def test2(url):
    import xbmcgui
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    q = parse_qs(o.query)
    #https://t66y.com/htm_data/2001/22/3772321.html
    #https://baiduyunbo.com/?id=uSIjcjPI
    if o.netloc == 'baiduyunbo.com' and 'id' in q:
        t = 'https://m3u8.cdnpan.com/%s.m3u8' % q['id'][0]
        return {'url': t}
    content = httpget(url)
    if not content:
        return {'code': 't66y 200', 'error': str(url)}
    #https://t66y.com/htm_data/2001/22/3772567.html
    #https://ppse016.com/play/video.php?id=66
    if o.netloc == 'ppse016.com':
        t = re.search(r'video: \'(.*?)\'', content)
        if t:
            t = t.group(1)
            return {'url': t}
    t = re.search(r'getElementById\(\'iframe1\'\)\.src=\'(.*?)\'', content)
    if t:
        t = t.group(1)
        xbmcgui.Dialog().ok('Info1', t)
        return test2(t)
    t = re.search(r'iframe src="(.*?)"', content)
    if t:
        t = t.group(1)
        t = re.search(r'url=http(.*)', t)
        if t:
            t = 'http' + t.group(1)
        xbmcgui.Dialog().ok('Info2', t)
        return {'url': t}
    # https://t66y.com/htm_data/2101/22/4300769.html
    # https://yaoshe142.com/embed/26828
    # https://t66y.com/htm_data/2101/22/4300767.html
    # https://ppx237.com/embed/15786
    t = re.search(r'flashvars = {(.*?)};', content, re.DOTALL)
    if t:
        t = t.group(1)
        rnd = re.search(r'rnd:\s*\'(.*?)\'', t)
        lrc = re.search(r'lrc:\s*\'(.*?)\'', t)
        video_url = re.search(r'video_url:\s*\'(.*?)\'', t)
        if rnd and video_url:
            rnd = rnd.group(1)
            video_url = video_url.group(1)
            # if 'xxhu37.com' in t:
            #     return {'code': 't66y xxhu37'}
            video_url = re.search(r'http(.*)', video_url)
            if video_url:
                video_url = video_url.group(0)
                if rnd:
                    video_url += '&rnd=' + rnd
                # https://t66y.com/htm_data/2101/22/4300772.html
                # https://kkembed.kdwshell.com/embed/86519
                if lrc:
                    xbmcgui.Dialog().ok('flashvars decrypt', video_url)
                return {'url': video_url}
    # https://t66y.com/htm_data/2101/22/4300784.html
    # https://oose026.com/play/video.php?id=5
    # https://t66y.com/htm_data/2101/22/4300615.html
    # https://baiduyunkan.com/embed/21322b748a7c633114a00ad44f7dafdf08b0c?id=1092
    t = re.search(r'DPlayer\((.*?)\);', content, re.DOTALL)
    if t:
        t = t.group(1)
        t1 = re.search(r'url:\s*\'(.*?)\',', t)
        if t1:
            t1 = t1.group(1)
            return {'url': t1.replace('https', 'http')}
    # https://t66y.com/htm_data/2101/22/4300777.html
    # https://www.888dav.com/vod/168516/
    t = re.search(r'player_data={(.*?)}', content, re.DOTALL)
    if t:
        t = '{' + t.group(1) + '}'
        data = json.loads(t)
        return {'url': data['url']}
    # https://t66y.com/htm_data/2101/22/4300714.html
    # http://91.9p9.xyz/ev.php?VID=1a17DB38YziY2J0ir6fNYtYPGLmaeLsDw2tnPzZrWoNNRJo48pQTAQ
    t = re.search(r'strencode\((.*?)\);', content)
    if t:
        t = '(' + t.group(1) + ')'
        xbmcgui.Dialog().ok('strencode decrypt', t)
    return {'code': 't66y 201'}
